using System;
using System.Collections;

namespace Model_View {
	public class ListModel {
		private ArrayList list;

		public enum Action {Added, Removed};
		public delegate void ListEventHandler(Action action, string text);
		public event ListEventHandler ListModified;

		public ListModel() {
			list = new ArrayList();
		}

		public void Add(string newText) {
			// Don't do anything if text is already in list
			foreach (string text in list) {
				if (text.Equals(newText)) {
					return;
				}
			}

			list.Add(newText);
			OnListModified(Action.Added, newText);
		}

		public void Remove(string oldText) {
			// Don't do anything if text is not in list
			int i = 0;
			foreach (string text in list) {
				if (text.Equals(oldText)) {
					list.RemoveAt(i);
					OnListModified(Action.Removed, oldText);
					break;
				}
				i++;
			}
		}

		/// <summary>
		/// Fire an event whenever the list is changed
		/// </summary>
		protected void OnListModified(Action action, string text) {
			if (ListModified != null) {
				ListModified(action, text);
			}
		}
	}
}