using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace Model_View {
	public class View : System.Windows.Forms.UserControl {
		private System.Windows.Forms.ContextMenu contextMenu;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.MenuItem menuAdd;
		private System.Windows.Forms.MenuItem menuRemove;
		private System.Windows.Forms.ListBox listBox;

		ListModel listModel;

		public View() {
			InitializeComponent();
		}

		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if(components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.listBox = new System.Windows.Forms.ListBox();
			this.contextMenu = new System.Windows.Forms.ContextMenu();
			this.menuAdd = new System.Windows.Forms.MenuItem();
			this.menuRemove = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// listBox
			// 
			this.listBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.listBox.ContextMenu = this.contextMenu;
			this.listBox.Location = new System.Drawing.Point(0, 0);
			this.listBox.Name = "listBox";
			this.listBox.Size = new System.Drawing.Size(288, 264);
			this.listBox.TabIndex = 0;
			// 
			// contextMenu
			// 
			this.contextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuAdd,
																						this.menuRemove});
			// 
			// menuAdd
			// 
			this.menuAdd.Index = 0;
			this.menuAdd.Text = "Add Item";
			this.menuAdd.Click += new System.EventHandler(this.menuAdd_Click);
			// 
			// menuRemove
			// 
			this.menuRemove.Index = 1;
			this.menuRemove.Text = "Remove Item";
			this.menuRemove.Click += new System.EventHandler(this.menuRemove_Click);
			// 
			// View
			// 
			this.Controls.Add(this.listBox);
			this.Name = "View";
			this.Size = new System.Drawing.Size(292, 266);
			this.ResumeLayout(false);

		}
		#endregion

		public ListModel ListModel {
			get { 
				return listModel;
			}
			set {
				listModel = value;
				if (listModel != null) {
					listModel.ListModified += new ListModel.ListEventHandler(listModel_ListModified);
				}
			}
		}

		private void menuAdd_Click(object sender, System.EventArgs e) {
			NewLabel newLabel = new NewLabel();
			newLabel.ShowDialog(this);
			listModel.Add(newLabel.Label);
		}

		private void menuRemove_Click(object sender, System.EventArgs e) {
			if (listBox.SelectedItem != null) {
				string text = listBox.SelectedItem.ToString();
				listModel.Remove(text);
			}
		}

		private void listModel_ListModified(Model_View.ListModel.Action action, string text) {
			switch (action) {
				case ListModel.Action.Added:
					listBox.Items.Add(text);
					break;
				case ListModel.Action.Removed:
					int i = 0;
					foreach (string item in listBox.Items) {
						if (item.Equals(text)) {
							listBox.Items.RemoveAt(i);
							break;
						}
						i++;
					}
					break;
			}
		}
	}
}